package dador.wildfly_debug.http_upgrade;

import java.io.*;
import java.util.concurrent.*;
import javax.servlet.*;

public class EchoReadListener implements ReadListener {

	final BlockingQueue<String> queue;
	final ServletInputStream in;

	public EchoReadListener(BlockingQueue<String> queue, ServletInputStream in) {
		super();
		this.in = in;
		this.queue = queue;
	}

	@Override
	public void onAllDataRead() throws IOException {
		System.out.println("listener onAllDataRead() called");
		System.out.println("here is data queued ...");
		for ( String s: this.queue) {
			System.out.println(s);
		}
		System.out.println("now do something");
	}

	@Override
	public void onDataAvailable() throws IOException {
		System.out.println("listener onDataAvailable() called");

		byte buffer[] = new byte[4 * 1024];
		int length = -1;
		while (this.in.isReady() && (length = this.in.read(buffer)) != -1) {
			String input = new String(buffer, 0, length);
			if (false == this.queue.offer(input)) {
				System.err.println("\'" + input.trim() + "\' input was ignored");
			}
			else {
				System.out.println("listener read \'" + input.trim() + "\'; successfully offered to queue");
			}
		}
	}

	@Override
	public void onError(Throwable t) {
		t.printStackTrace(System.err);
	}
}
